
OSTYPE=$(shell uname -s)
HOSTNAME=$(shell hostname)

ifeq ($(OSTYPE),Darwin)
OSARCH=$(shell uname -p)
else
OSARCH=$(shell uname -m)
endif

CFLAGS= -O2 \
	-I../xge \
	-I/usr/include \
	-I/usr/local/include \
	-I/opt/local/include \
	-I/usr/X11/include \
	-I/usr/include/libxml2
 	
LDFLAGS= \
	-L/usr/lib \
	-L/usr/local/lib \
	-L/opt/local/lib/ \
	-L/usr/X11/lib 


ifeq ($(prefix_qhull),) 
CFLAGS+= -I/usr/include/qhull
LDFLAGS+= -L/usr/lib/qhull
else
CFLAGS+= -I$(prefix_qhull) -I$(prefix_qhull)/include/qhull -I$(prefix_qhull)/src
LDFLAGS+= -L$(prefix_qhull) -L$(prefix_qhull)/src/.libs -L$(prefix_qhull)/lib
endif

ifeq ($(prefix_mzscheme),) 
CFLAGS+= -I/usr/include/plt 
LDFLAGS+= -L/usr/lib/plt
else
CFLAGS+= -I$(prefix_mzscheme) -I$(prefix_mzscheme)/include
LDFLAGS+= -L$(prefix_mzscheme) -L$(prefix_mzscheme)/lib
endif

ifeq ($(prefix_gsl),) 
CFLAGS+= 
LDFLAGS+= 
else
CFLAGS+= -I$(prefix_gsl) -I$(prefix_gsl)/include
LDFLAGS+= -L$(prefix_gsl) -L$(prefix_gsl)/lib
endif

CPPFLAGS= -Wno-deprecated  $(CFLAGS)

ifeq ($(OSTYPE),Linux)
LDFLAGS+=-lmzscheme -lmzgc -lgsl -lgslcblas -lqhull -lm -lpthread -lxml2 -lGL -lglut
endif

ifeq ($(OSTYPE),Darwin)
LDFLAGS+=-lmzscheme -lmzgc -lgsl -lgslcblas -lqhull -lm -lpthread -lxml2 -framework OpenGL -framework GLUT  -framework Carbon -liconv
endif





