;==================================================
; MzPlasm
; Author: Simone Portuesi, Giorgio Scorzelli
; DATE: January 2007
;==================================================



; move somewhere else, however not in PlasmAnim.scm as that has to be loaded aftere f_envs.scm
(require (lib "43.ss" "srfi"))
(define-struct anim-pol-complex (pol id tStart tEnd))
;(define-struct ML (L))
;(define-struct KL (len L))

(define (Plasm_Printer plasmobj port)
  (if (not (output-port? port)) 
      (set! port (current-output-port)))
  
  (let loop ((obj plasmobj))
    
    ; *** SYMBOL ****
    (if (symbol? obj)
    	(if (not (eq? obj 'Plasm_value))
	    (display obj port)
					 ))
    
    ; *** NUMBER ****
    (if (or (number? obj) (char? obj))  
        (begin
          (display obj port)))
    
    ; *** STRING ****
    (if (string? obj) 
        (begin (display #\' port)
               (display obj port)
               (display #\' port)))
    
    ; *** PROCEDURE ****
    (if (procedure? obj)
        (if (isclass obj) 
            (begin
              (display "Plasm Class ")
              (display (obj '§_name_§)))
            (if (isobject obj)
                (begin
                  (display "Plasm Object of Class ")
                  (PrintObj obj port))
		(begin
		  (display "An-Anonymous-Function (" port)
		  (display obj)
		  (display ")")))))
    
    ; *** POL COMPLEX ****
    (if (and *USE_GEOMETRY* (pol-complex? obj))
        (begin
          (display "PolComplex ")
          ;(newline)
          (Plasm_Printer `(,(send obj get-dpol-dim),(send obj get-npol-dim)) port)))

    (if (and *USE_GEOMETRY* (anim-pol-complex? obj))
        (begin
          (display "AnimPolComplex:")
	  (newline)
	  (display "   Id:")
	  (display (anim-pol-complex-id obj))
	  (newline)
	  (display "   tStart=")
	  (display (anim-pol-complex-tStart obj))
	  (newline)
	  (display "   tEnd=")
	  (display (anim-pol-complex-tEnd obj))
	  (newline)
	  (display "   ")
	  (Plasm_Printer (anim-pol-complex-pol obj) port)))
    
    ; *** BOOLEAN ****
    (if (boolean? obj) 
        (if obj (display "True") (display "False")))
    
    ; *** LIST ****
    (if (list? obj)
        (if (null? obj)
            (display "<>" port)
            (let ((in_str (if (every char? obj) #t #f)))
              
              (if in_str (display "'") (display "< " port) )
              (loop (car obj))
              
              
              (for-each (lambda (item) 
                          (if (not in_str)  (display " , " port))
                          (loop item))
                        
                        (cdr obj))
              (if in_str (display "'") (display " >" port))
              )))

    (if (vector? obj) 
        (cond ((eq? (vector-length obj) 0)
	       (display "| !!!!! |" port))
	      (#t (begin
		    (display "|" port) 
		    (display (vector-length obj) port)
		    (display "# " port)
		    (vector-for-each (lambda (i item) 
				       (if (not (eq? i 0)) (display " . " port))
				       (loop item))
				     obj)
		    (display " |"  port) ))
	      ))
	
   ;;  (if (KL? obj) 
;;         (cond ((null? (KL-L obj)) (begin
;; 				    (display ">" port) 
;; 				    (display (KL-len obj) port)
;; 				    (display "# <" port)))
;; 	      ((pair? (KL-L obj)) (begin
;; 				       (display ">" port) 
;; 				       (display (KL-len obj) port)
;; 				       (display "# " port)
;; 				       (loop (car (KL-L obj)))
;; 				       (for-each (lambda (item) 
;; 						   (display " ' " port)
;; 						   (loop item))
;; 						 (cdr (KL-L obj)))
;; 				       (display " <" port)
;; 				       ))
;; 	      (#t (begin
;; 		    (display ">" port) 
;; 		    (display (KL-len obj) port)
;; 		    (display "# ")
;; 		    (loop (KL-L obj))
;; 		    (display " <" port)))))
	

    ; *** PROPERTIES ***
	(if (or (list? obj) (number? obj) (char? obj) (string? obj) (boolean? obj) (procedure? obj)
		(and *USE_GEOMETRY* (pol-complex? obj)))
		(if (has-property? obj)
    	(let ((props (plasm-list-gp obj)))
	      ;(display props)
		  (if (not (null? props))
		  (begin 
		    (display " $ ")
		    (loop props ))))))
	  

	
    )
  
  (newline)
  )


(define (PrintObj obj port)
  (let ((value (obj '§_value_§)))
    (display ((obj '§_class_§) '§_name_§))
    (display " ")
    (if (isobject value) 
	(PrintObj value port)
	(begin
	  (display "and Value ")
	  (Plasm_Printer value port)))))

    
