#ifndef _XML2DPATH_H__
#define _XML2DPATH_H__

#include "generaldef.h"
#include "ggraph.h"

#include <map>

extern std::map<key,float> scalarfield;
extern std::map<key,int>   colorfield;

class Xml2DPath
{
protected:

	char filename[1024];
	ggraph* g2;
	int limit;

	static void startElement(void *ctx, const unsigned char  *name, const unsigned char  **atts);

	void removeWrongCells();
	void setNormals();

public:

	// constructor
	Xml2DPath(char* filename,int limit=0);

	//destructor
	~Xml2DPath();

	//parse file
	void parse();

	//access the graph
	ggraph* getGraph();


}; //end class


#endif //_XML2DPATH_H__


