/* -------------------------------------------------------------------------- *\
   Project..........:   eXtreme Geometric Environment for PLaSM
   Copyright........:   Universita' degli studi di ROMA TRE
                        Dipartimento di Informatica e Automazione 
                        Via Vasca Navale 84, 00146 ROMA
	Development by...:	Giorgio Scorzelli
	E-Mail...........:	scorzell.uniroma3.it
	Environment......:	Win32, UNIX
\* -------------------------------------------------------------------------- */


#include "generaldef.h"


#include "bsp.h"
#include "ggraph.h"
#include "mat.h"
#include "gbool.h"


ggraph** ggraph::skeleton(int level,int& num)
{
	key Points[MAX_CELLS_PER_LEVEL];
	ggraph** ret;
	int cont=0;
	num=(pointdim==level)?1:getNCells(level);
	ret=new ggraph*[num];

	if (pointdim==level)
	{
		ret[cont++]=this->clone();
	}
	else
	{
		for (ggraph::list_iterator it=each(level);!it.end();it++)
		{
			key NPoints=findCells(0,*it,Points);
			ret[cont++]=mkpol(NPoints,Points);
		}
	}
	
	return ret;
}
