#ifndef _RAYSHOOTING_2D_H__
#define _RAYSHOOTING_2D_H__

#include "generaldef.h"
#include  "ggraph.h"

/*
class which test if a point is inside or outside cell F of a 2d-ggraph
using ray-shooting method along ray (vx,vy)
*/

class RayShooting2d
{
	ggraph* g;
	real vx,vy;
	float totseconds;
	
	//transformation such that (vx,vy)->(1,0). Must be vy<>0
	void transformPoint(real& X,real& Y);

public:

	//constructor
	RayShooting2d(real vx,real vy,const ggraph* _g);

	//destructor
	~RayShooting2d();

	//access the graph
	inline ggraph* getGraph();

	//get the cell
	key getCell(real X,real Y);
};


///////////////
//INLINES
///////////////

inline void RayShooting2d::transformPoint(real& X,real& Y)
{
	real x=+X-Y*vx/vy; 
	real y=+Y/vy;      
	X=x;Y=y;
}


inline ggraph* RayShooting2d::getGraph()
{
	return this->g;
}

#endif // _RAYSHOOTING_2D_H__



